/**
 * @properties={typeid:35,uuid:"FEBFA80D-FC07-4784-96B1-9288B5A2D7C9",variableType:-4}
 */
var accepted_filters = null;

/**
 * @properties={typeid:35,uuid:"462BEEDA-F5A8-4F3E-9506-50305B997ACF",variableType:-4}
 */
var actions = ["load", "export", "report"];

/**
 * @properties={typeid:35,uuid:"291B1019-6D95-4516-8E54-CE1A5C37185F",variableType:-4}
 */
var addingParts = {
	status: "AND LM.STATO_LETTERA = ?",
	type: "AND SKA.TIPO_ANOMALIA = ?",
	subtype: "AND SKA.SOTTOTIPO_ANOMALIA = ?",
	def_reason: "AND SKA.ATTRIBUZIONE = ?",
	mod_reason: "AND SKM.CAUSALE_MODIFICA = ?"
};

/**
 * @properties={typeid:35,uuid:"68F76508-EF1E-4A74-A757-7CEB046E543F",variableType:-4}
 */
var args = null;

/**
 * @properties={typeid:35,uuid:"DD219F93-98DE-4FBF-90B6-672E03B7A5AF",variableType:-4}
 */
var container = null;

/**
 * @properties={typeid:35,uuid:"E9FA9CD2-C676-4FBB-9114-7037434652BB",variableType:-4}
 */
var filters = ["mod_reason", "history_flag"];

/**
 * @type {String}
 *
 * @properties={typeid:35,uuid:"A4E23CC5-8B96-4A98-A85D-D49505DBE710"}
 */
var query = "";

/**
 * @properties={typeid:35,uuid:"C9D40BC7-B95C-4FA1-B67E-1805581F881A",variableType:-4}
 */
var query_ex = { query: null, args: null, form: null };

/**
 * @properties={typeid:35,uuid:"3027927A-9E94-46BD-A948-D6A04E75290A",variableType:-4}
 */
var query_exGraphical = { query: null, args: null, form: null };

/**
 * @type {String}
 *
 * @properties={typeid:35,uuid:"5BE587F2-22A4-4BA1-B693-58E00C00E4DC"}
 */
var replacePart = "(LM.PROGETTO IN **MODELS_HERE** OR LM.VERSIONE IN **VERSIONS_HERE**)";

/**
 * @properties={typeid:35,uuid:"EF4A7AF3-1632-49E8-89C7-F1DD6C379295",variableType:-4}
 */
var title = null;

/**
 * Callback method when form is (re)loaded.
 *
 * @param {JSEvent} event the event that triggered the action
 *
 * @properties={typeid:24,uuid:"9BB6AD1C-2B31-49F6-8B80-D64CA541AF45"}
 */
function onLoad(event) {
	container = forms.report_istogrammi;
	//Aggiungo il listener per il click
	//FS
	//dep	elements.chart.addMouseListener(container.rightClickHandler);
	/** @type {java.awt.event.MouseListener} */
	var rightClickHandler = container.rightClickHandler;
	elements.chart.addMouseListener(rightClickHandler);
	//Setto le query e i parametri TRANNE il primo l'ultimo, che verranno generati dal metodo di generazione del chart
	setupInfo(true);
	title = "Lettere di Modifica";
}

/**
 * Callback method for when form is shown.
 *
 * @param {Boolean} firstShow form is shown first time after load
 * @param {JSEvent} event the event that triggered the action
 *
 * @properties={typeid:24,uuid:"8A0A07B9-EB4F-450B-94F2-05A74E40DD2C"}
 */
function onShowForm(firstShow, event) {
	container.selected = controller.getName();
	if (firstShow) {
		container.setupChart();
	}
	container.setLocalHelpMessage("Una \"Lettera di modifica\" si intende CHIUSA quando\nè presente una data di introduzione modifica o un\nnumero assembly, altrimenti è da considerarsi APERTA.\nUna \"Lettera di modifica\" annullata è considerata CHIUSA.");
	container.checkFiltersOnShow();
	container.setupFilters();
	container.drawChart();
}

/**
 * @properties={typeid:24,uuid:"44B49216-518F-4C5D-B506-40985E80FAA1"}
 */
function setupInfo(_history) {
	var q_noHistory = "SELECT FILTERX_, FILTERY_, COUNT(*) COUNT_ FROM (SELECT **X_HERE** FILTERX_, 'Categoria unica' FILTERY_ FROM (SELECT LM.STATO_LETTERA STATUS_, SKM.GRUPPO_FUNZIONALE GROUP_, SKM.GRUPPO_FUNZIONALE || TRIM(SKM.GRUPPO_FUNZIONALE2) FULLGROUP_, TRIM(SKM.ENTE_PROPOSTA_MODIFICA) DEPARTMENT_, TRIM(SKM.LEADER) LEADER_, SKM.CAUSALE_MODIFICA MOD_REASON_, (SELECT COUNT(*) FROM K8_SEGNALAZIONI_FULL I INNER JOIN K8_SCHEDE_MODIFICA J ON I.ENTE = J.ENTE_INSERIMENTO_ANOMALIA AND I.NUMERO_SCHEDA = J.NR_SCHEDA_ANOMALIA WHERE J.K8_SCHEDE_MODIFICA_ID = SKM.K8_SCHEDE_MODIFICA_ID) HISTORY_, SKM.TIPO_APPROVAZIONE APPROVAL_ FROM K8_SCHEDE_MODIFICA SKM INNER JOIN K8_LETTERE_MODIFICA LM ON SKM.NR_PROPOSTA_MODIFICA = LM.NUMERO_LETTERA WHERE (LM.PROGETTO IN **MODELS_HERE** OR LM.VERSIONE IN **VERSIONS_HERE**))) GROUP BY FILTERX_, FILTERY_ ORDER BY FILTERX_, FILTERY_";
	var q_history = "SELECT FILTERX_, FILTERY_, **VIEW_HERE** COUNT_ FROM (SELECT **X_HERE** FILTERX_, **Y_HERE** FILTERY_, FACTOR_ FROM (SELECT LM.STATO_LETTERA STATUS_, SKM.GRUPPO_FUNZIONALE GROUP_, SKM.GRUPPO_FUNZIONALE || TRIM(SKM.GRUPPO_FUNZIONALE2) FULLGROUP_, TRIM(SKM.ENTE_PROPOSTA_MODIFICA) DEPARTMENT_, TRIM(SKM.LEADER) LEADER_, TRIM(SKA.SEGNALATO_DA) REPORTER_, SKA.GESTIONE_ANOMALIA MANAGEMENT_, TRIM(SKA.RESPONSABILE) RESPONSIBLE_, SKM.CAUSALE_MODIFICA MOD_REASON_, (SELECT COUNT(*) FROM K8_SEGNALAZIONI_FULL I INNER JOIN K8_SCHEDE_MODIFICA J ON I.ENTE = J.ENTE_INSERIMENTO_ANOMALIA AND I.NUMERO_SCHEDA = J.NR_SCHEDA_ANOMALIA WHERE J.K8_SCHEDE_MODIFICA_ID = SKM.K8_SCHEDE_MODIFICA_ID) HISTORY_, SKM.TIPO_APPROVAZIONE APPROVAL_, TO_NUMBER(SKA.PUNTEGGIO_DEMERITO) SEVERITY_, SKA.TIPO_ANOMALIA TYPE_, SKA.TIPO_COMPONENTE TCOM_, SKA.ATTRIBUZIONE DEF_REASON_, NVL(TO_NUMBER(SKA.PUNTEGGIO_DEMERITO),0) FACTOR_ FROM K8_SEGNALAZIONI_FULL SKA INNER JOIN K8_SCHEDE_MODIFICA SKM ON SKA.ENTE = SKM.ENTE_INSERIMENTO_ANOMALIA AND SKA.NUMERO_SCHEDA = SKM.NR_SCHEDA_ANOMALIA INNER JOIN K8_LETTERE_MODIFICA LM ON SKM.NR_PROPOSTA_MODIFICA = LM.NUMERO_LETTERA WHERE (LM.PROGETTO IN **MODELS_HERE** OR LM.VERSIONE IN **VERSIONS_HERE**))) GROUP BY FILTERX_, FILTERY_ ORDER BY FILTERX_, FILTERY_";

	var q_exNoHistory = "SELECT ID_ FROM (SELECT SKM.K8_SCHEDE_MODIFICA_ID ID_, LM.STATO_LETTERA STATUS_, SKM.GRUPPO_FUNZIONALE GROUP_, SKM.GRUPPO_FUNZIONALE || TRIM(SKM.GRUPPO_FUNZIONALE2) FULLGROUP_, TRIM(SKM.ENTE_PROPOSTA_MODIFICA) DEPARTMENT_, TRIM(SKM.LEADER) LEADER_, SKM.CAUSALE_MODIFICA MOD_REASON_, (SELECT COUNT(*) FROM K8_SEGNALAZIONI_FULL I INNER JOIN K8_SCHEDE_MODIFICA J ON I.ENTE = J.ENTE_INSERIMENTO_ANOMALIA AND I.NUMERO_SCHEDA = J.NR_SCHEDA_ANOMALIA WHERE J.K8_SCHEDE_MODIFICA_ID = SKM.K8_SCHEDE_MODIFICA_ID) HISTORY_, SKM.TIPO_APPROVAZIONE APPROVAL_ FROM K8_SCHEDE_MODIFICA SKM INNER JOIN K8_LETTERE_MODIFICA LM ON SKM.NR_PROPOSTA_MODIFICA = LM.NUMERO_LETTERA WHERE (LM.PROGETTO IN **MODELS_HERE** OR LM.VERSIONE IN **VERSIONS_HERE**)) WHERE **X_HERE** = ?";
	var q_exHistory = "SELECT ID_ FROM (SELECT SKM.K8_SCHEDE_MODIFICA_ID ID_, LM.STATO_LETTERA STATUS_, SKM.GRUPPO_FUNZIONALE GROUP_, SKM.GRUPPO_FUNZIONALE || TRIM(SKM.GRUPPO_FUNZIONALE2) FULLGROUP_, TRIM(SKM.ENTE_PROPOSTA_MODIFICA) DEPARTMENT_, TRIM(SKM.LEADER) LEADER_, TRIM(SKA.SEGNALATO_DA) REPORTER_, SKA.GESTIONE_ANOMALIA MANAGEMENT_, TRIM(SKA.RESPONSABILE) RESPONSIBLE_, SKM.CAUSALE_MODIFICA MOD_REASON_, (SELECT COUNT(*) FROM K8_SEGNALAZIONI_FULL I INNER JOIN K8_SCHEDE_MODIFICA J ON I.ENTE = J.ENTE_INSERIMENTO_ANOMALIA AND I.NUMERO_SCHEDA = J.NR_SCHEDA_ANOMALIA WHERE J.K8_SCHEDE_MODIFICA_ID = SKM.K8_SCHEDE_MODIFICA_ID) HISTORY_, SKM.TIPO_APPROVAZIONE APPROVAL_, TO_NUMBER(SKA.PUNTEGGIO_DEMERITO) SEVERITY_, SKA.TIPO_ANOMALIA TYPE_, SKA.TIPO_COMPONENTE TCOM_, SKA.ATTRIBUZIONE DEF_REASON_, NVL(TO_NUMBER(SKA.PUNTEGGIO_DEMERITO),0) FACTOR_ FROM K8_SEGNALAZIONI_FULL SKA INNER JOIN K8_SCHEDE_MODIFICA SKM ON SKA.ENTE = SKM.ENTE_INSERIMENTO_ANOMALIA AND SKA.NUMERO_SCHEDA = SKM.NR_SCHEDA_ANOMALIA INNER JOIN K8_LETTERE_MODIFICA LM ON SKM.NR_PROPOSTA_MODIFICA = LM.NUMERO_LETTERA WHERE (LM.PROGETTO IN **MODELS_HERE** OR LM.VERSIONE IN **VERSIONS_HERE**)) WHERE **X_HERE** = ?";

	var q_exGraphNoHistory = "SELECT ID_ FROM (SELECT SKM.K8_SCHEDE_MODIFICA_ID ID_, LM.STATO_LETTERA STATUS_, SKM.GRUPPO_FUNZIONALE GROUP_, SKM.GRUPPO_FUNZIONALE || TRIM(SKM.GRUPPO_FUNZIONALE2) FULLGROUP_, TRIM(SKM.ENTE_PROPOSTA_MODIFICA) DEPARTMENT_, TRIM(SKM.LEADER) LEADER_, SKM.CAUSALE_MODIFICA MOD_REASON_, (SELECT COUNT(*) FROM K8_SEGNALAZIONI_FULL I INNER JOIN K8_SCHEDE_MODIFICA J ON I.ENTE = J.ENTE_INSERIMENTO_ANOMALIA AND I.NUMERO_SCHEDA = J.NR_SCHEDA_ANOMALIA WHERE J.K8_SCHEDE_MODIFICA_ID = SKM.K8_SCHEDE_MODIFICA_ID) HISTORY_, SKM.TIPO_APPROVAZIONE APPROVAL_ FROM K8_SCHEDE_MODIFICA SKM INNER JOIN K8_LETTERE_MODIFICA LM ON SKM.NR_PROPOSTA_MODIFICA = LM.NUMERO_LETTERA WHERE (LM.PROGETTO IN **MODELS_HERE** OR LM.VERSIONE IN **VERSIONS_HERE**)) WHERE **X_HERE** = ?";
	var q_exGraphHistory = "SELECT ID_ FROM (SELECT SKM.K8_SCHEDE_MODIFICA_ID ID_, LM.STATO_LETTERA STATUS_, SKM.GRUPPO_FUNZIONALE GROUP_, SKM.GRUPPO_FUNZIONALE || TRIM(SKM.GRUPPO_FUNZIONALE2) FULLGROUP_, TRIM(SKM.ENTE_PROPOSTA_MODIFICA) DEPARTMENT_, TRIM(SKM.LEADER) LEADER_, TRIM(SKA.SEGNALATO_DA) REPORTER_, SKA.GESTIONE_ANOMALIA MANAGEMENT_, TRIM(SKA.RESPONSABILE) RESPONSIBLE_, SKM.CAUSALE_MODIFICA MOD_REASON_, (SELECT COUNT(*) FROM K8_SEGNALAZIONI_FULL I INNER JOIN K8_SCHEDE_MODIFICA J ON I.ENTE = J.ENTE_INSERIMENTO_ANOMALIA AND I.NUMERO_SCHEDA = J.NR_SCHEDA_ANOMALIA WHERE J.K8_SCHEDE_MODIFICA_ID = SKM.K8_SCHEDE_MODIFICA_ID) HISTORY_, SKM.TIPO_APPROVAZIONE APPROVAL_, TO_NUMBER(SKA.PUNTEGGIO_DEMERITO) SEVERITY_, SKA.TIPO_ANOMALIA TYPE_, SKA.TIPO_COMPONENTE TCOM_, SKA.ATTRIBUZIONE DEF_REASON_, NVL(TO_NUMBER(SKA.PUNTEGGIO_DEMERITO),0) FACTOR_ FROM K8_SEGNALAZIONI_FULL SKA INNER JOIN K8_SCHEDE_MODIFICA SKM ON SKA.ENTE = SKM.ENTE_INSERIMENTO_ANOMALIA AND SKA.NUMERO_SCHEDA = SKM.NR_SCHEDA_ANOMALIA INNER JOIN K8_LETTERE_MODIFICA LM ON SKM.NR_PROPOSTA_MODIFICA = LM.NUMERO_LETTERA WHERE (LM.PROGETTO IN **MODELS_HERE** OR LM.VERSIONE IN **VERSIONS_HERE**)) WHERE **X_HERE** = ? AND **Y_HERE** = ?";

	if (!_history) {
		query = q_noHistory;
		query_ex.query = q_exNoHistory;
		query_exGraphical.query = q_exGraphNoHistory;
		accepted_filters = [0, 1, 2, 3, 4, 8, 9, 10];
	} else {
		query = q_history;
		query_ex.query = q_exHistory;
		query_exGraphical.query = q_exGraphHistory;
		accepted_filters = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12];
	}
	args = [];
	query_ex.args = [];
	query_ex.form = forms.schede_modifica_record.controller.getName();
	query_exGraphical.args = [];
	query_exGraphical.form = forms.schede_modifica_record.controller.getName();
}
